// /////////////////////////////////////////////////////////////////////////
// SystemC code automatically generated by hif2sc
// Part of HIFSuite - Version stable
// Site: www.hifsuite.com - Contact: hifsuite@edalab.it
//
// HIFSuite copyright: EDALab s.r.l. - Networked Embedded Systems
// Site: www.edalab.it - Contact: info@edalab.it
// /////////////////////////////////////////////////////////////////////////


#ifndef WATCHDOG_APB_WRAPPER_HH
#define WATCHDOG_APB_WRAPPER_HH

#include <stdint.h>
#include <systemc>

class watchdog_apb_wrapper :
    public sc_core::sc_module
{

public:

    sc_core::sc_in< bool > pclk;
    sc_core::sc_in< bool > presetn;
    sc_core::sc_in< uint32_t > paddr;
    sc_core::sc_in< bool > psel;
    sc_core::sc_in< bool > penable;
    sc_core::sc_in< bool > pwrite;
    sc_core::sc_in< uint32_t > pwdata;
    sc_core::sc_out< bool > pready;
    sc_core::sc_out< uint32_t > prdata;
    sc_core::sc_vector< sc_core::sc_signal< bool > > prdata_mspw;
    sc_core::sc_signal< uint16_t > prdata_partial2;
    bool prdata_partial1;
    uint16_t prdata_partial0;
    bool start_counting;
    bool stop_counting;
    uint16_t max_counter;
    sc_core::sc_signal< uint16_t > actual_counter;
    sc_core::sc_signal< bool > counter_flag;
    sc_core::sc_signal< bool > dout_rdy;
    sc_core::sc_signal< uint8_t > watchdog_0_state;
    uint8_t old_watchdog_0_state;
    uint8_t watchdog_0_state_sig_var;
    sc_core::sc_signal< uint8_t > watchdog_0_next_state;
    sc_core::sc_signal< uint32_t > watchdog_0_internal_max_counter;

    void hif_cone_max_counter();


    void hif_cone_prdata_partial0();


    void hif_cone_prdata_partial1();


    void hif_cone_start_counting();


    void hif_cone_stop_counting();


    void hif_cone_watchdog_0_state();


    void start_of_simulation();


    const uint8_t watchdog_0_st_1;
    const uint8_t watchdog_0_st_2;
    const uint8_t watchdog_0_st_3;
    const uint8_t watchdog_0_st_4;
    const uint8_t watchdog_0_st_5;


    SC_HAS_PROCESS( watchdog_apb_wrapper );

    watchdog_apb_wrapper( sc_core::sc_module_name name_ );
    ~watchdog_apb_wrapper();


private:

    watchdog_apb_wrapper( const watchdog_apb_wrapper & );
    const watchdog_apb_wrapper& operator= ( const watchdog_apb_wrapper & );


    void watchdog_0_process();
    void watchdog_0_process_0();
    void globact_process();
    void globact_process_0();
    void globact_process_1();
    void globact_process_2();
    void globact_process_18();
    void prdata_mspw_proc_tgt();


};


#endif

